﻿package{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	
	public class Timeline extends Sprite{
		
		private var _screen:BitmapData;
		private var cursor:Sprite;
		private var cursor2:Sprite;
		public function Timeline(){
			/*on cree le background ou les vecteurs vont être arrêtés*/
			_screen = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			/*on en fait un bitmap*/
			var bitmap:Bitmap = new Bitmap(_screen);
			/*on affiche le bitmap*/
			addChild(bitmap);
			/*on cré un curseur de balayage (vertical)*/
			cursor = new Sprite();
			cursor.graphics.beginFill(0xffffff,0.5);
			cursor.graphics.drawRect(0,0,stage.stageWidth,1);
			cursor.graphics.endFill();
			/*on affiche le curseur*/
			addChildAt(cursor,1);
			/*on cré un curseur de balayage (horizontal)*/
			cursor2 = new Sprite();
			cursor2.graphics.beginFill(0xfffffff,0.5);
			cursor2.graphics.drawRect(0,0,1,stage.stageHeight);
			cursor2.graphics.endFill();
			/*on affiche le curseur*/
			addChildAt(cursor2,1);
			/*on affecte un evenement ENTERFRAME*/
			addEventListener(Event.ENTER_FRAME,onEnterFrame);
			}
			
		private function onEnterFrame(e:Event):void{
			/*on fait avancer le curseur, s'il arrive au bout du stage, on le met à 0*/
			if(cursor.y> stage.stageHeight){
				cursor.y =0;
				}else{
				cursor.y++;	
				}
				if(cursor2.x> stage.stageWidth){
				cursor2.x =0;
				}else{
				cursor2.x++;	
			}
			/*on vérifie une distance d'approche entre le curseur et la souris*/
			if(Math.abs(cursor.y-this.mouseY) <= 20){
				/*on lance une fonction de création avec les coordonées de la souris*/
				buildSquaresV(this.mouseX,this.mouseY);
			}
			if(Math.abs(cursor2.x-this.mouseX) <= 20){
				/*on lance une fonction de création avec les coordonées de la souris*/
				buildSquaresH(this.mouseX,this.mouseY);
			}
		}
		private function buildSquaresV(_xpos,_ypos){
				/*on se cré un stylo avec lequelle on va dessiner un cercle et un fond rouge super transparent*/
				var stylo:Sprite = new Sprite();
				stylo.graphics.beginFill(0x888888,.004);
				stylo.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
				stylo.graphics.endFill();
				stylo.graphics.beginFill(0xffffff,.2);
				stylo.graphics.lineStyle(2,0x000000,.5);
				stylo.graphics.drawRect(_xpos,_ypos,Math.random()*50,Math.random()*100);
				/*on copie le dessin du stylo dans notre background*/
				_screen.draw(stylo);
		}
		private function buildSquaresH(_xpos,_ypos){
				/*on se cré un stylo avec lequelle on va dessiner un cercle et un fond rouge super transparent*/
				var stylo2:Sprite = new Sprite();
				stylo2.graphics.beginFill(0x999999,.004);
				stylo2.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
				stylo2.graphics.endFill();
				stylo2.graphics.beginFill(0xffffff,.2);
				stylo2.graphics.lineStyle(2,0x000000,.5);
				stylo2.graphics.drawRect(_xpos,_ypos,Math.random()*50,Math.random()*100);
				/*on copie le dessin du stylo dans notre background*/
				_screen.draw(stylo2);
		}
	}
}